#############################################################################################
# PoD-Profile-Finder																		#
# Version: 			v1.0 [Date: 17.10.2012]												#
# Written by:																				#
#					TheSpeedFreak (Steam)													#
#					SpeedFreak (Eventscripts Forum)											#
#																							#
# Special Thanks to:																		#
#					Mattie:				Eventscripts Plugin									#
#					All Editors of: 	https://developer.valvesoftware.com/wiki/SteamID	#
#																							#
# Website: 			www.NextGenerationGaming.de												#
# Description: 		Converts Steam IDs to Community IDs.									#
#############################################################################################

import es
import popuplib
import playerlib
import usermsg
import gamethread

#Globals
hide = 1

#Lists
cmdList = []
adminList = []
playerList = []

#Info
info = es.AddonInfo() 
info.name     	= 'PoD-Profile-Finder' 
info.basename 	= 'pod_profile_finder'
info.version  	= es.ServerVar('pod_profile_finder_version')
info.url      	= 'http://addons.eventscripts.com/addons/view/PoD-Profile-Finder' 
info.description = 'Mod to convert SteamIDs to Community IDs'
info.author   	= 'Steam: TheSpeedFreak | Eventscripts Forum: SpeedFreak'

def load():
	es.set('pod_profile_finder_version', 'v1.0')
	es.makepublic('pod_profile_finder_version')
	es.addons.registerSayFilter(sayfilter)
	es.set("pod_profile_finder_hide",1)
	es.set("pod_profile_finder_cmd","")
	es.set("pod_profile_finder_admins","")
	es.server.queuecmd("es_xmexec ../addons/eventscripts/pod_profile_finder/config.cfg")
	gamethread.delayed(1,setVars)

def unload():
	es.addons.unregisterSayFilter(sayfilter)
	for userid in es.getUseridList(): whisper(userid,'%s #greensuccessfully unloaded!' % es.ServerVar('pod_profile_finder_version'))

def player_disconnect(ev):
	steamid = ev['networkid']
	name = ev['name']
	if steamid != 'BOT':
		for entry in playerList:
			if entry[0] == steamid: playerList.remove(entry)
		if steamid not in playerList: playerList.insert(0,(steamid,name))
		if len(playerList) > 20: playerList.pop(20)

def setVars():
	global cmdList, adminList, hide
	hide = es.ServerVar("pod_profile_finder_hide")
	if es.ServerVar("pod_profile_finder_cmd") != "" or es.ServerVar("pod_profile_finder_cmd") != '': cmdList = str(es.ServerVar("pod_profile_finder_cmd")).split(';')
	if es.ServerVar("pod_profile_finder_admins") != "" or es.ServerVar("pod_profile_finder_admins") != '': adminList = str(es.ServerVar("pod_profile_finder_admins")).split(';')
	for userid in es.getUseridList(): whisper(userid,'%s #greensuccessfully loaded!' % es.ServerVar('pod_profile_finder_version'))

def sayfilter(userid,text,team):
	steamid = es.getplayersteamid(userid)
	text = text.strip('"')
	if len(adminList) == 0 or (len(adminList) > 0 and steamid in adminList):
		if text in cmdList:
			popupCreate(userid,1)
			if hide: return (0,0,0)
		else:
			for word in cmdList:
				if text.startswith(word+' '):
					arg = text[len(word)+1:len(text)]
					if arg.startswith('STEAM_'):
						openProfile(userid,getSteamid(userid,arg))
					else:
						target = es.getuserid(arg)
						if target:
							targetSteamid = es.getplayersteamid(target)
							if targetSteamid == 'BOT':
								playSound(userid,0)
								whisper(userid,'Error: #greenTarget Player is a Bot!')
							else:
								openProfile(userid,getSteamid(userid,targetSteamid))
						else:
							playSound(userid,0)
							whisper(userid,'Error: #greenPlayer with Name/ID \x0720B2AA%s #greennot found!' % arg)
					if hide: return (0,0,0)
					break
	return (userid,text,team)

def popupCreate(userid,popupID):
	#1 = Online / Offline
	#2 = Playerlist (Online)
	#3 = Playerlist (Offline)
	temp = popuplib.easymenu('pod_profile_finder',None,popupOutput)
	temp.settitle('PoD-Profile-Finder')
	if popupID == 1:
		temp.setdescription('Select a Playerlist')
		temp.addoption('online','Online Playerlist')
		temp.addoption('offline','Offline Playerlist\n-----------------------------')
		temp.addoption('about','About')
		temp.addoption('help','How to use')
	if popupID == 2:
		temp.setdescription('Select a Player')
		for player in playerlib.getPlayerList('#spec'):
			if player.steamid != 'BOT' and player.steamid != 'STEAM_ID_PENDING': temp.addoption(player.steamid,'[SPEC] '+player.name)
		for player in playerlib.getPlayerList('#t'):
			if player.steamid != 'BOT' and player.steamid != 'STEAM_ID_PENDING': temp.addoption(player.steamid,'[T] '+player.name)
		for player in playerlib.getPlayerList('#ct'):
			if player.steamid != 'BOT' and player.steamid != 'STEAM_ID_PENDING': temp.addoption(player.steamid,'[CT] '+player.name)
	if popupID == 3:
		temp.setdescription('Select a Player')
		for entry in playerList: temp.addoption(entry[0],entry[1])
	temp.send(userid)
	temp.delete()

def popupOutput(userid,choice,popupname):
	if choice.startswith('STEAM_') and choice != 'STEAM_ID_PENDING':
		openProfile(userid,getSteamid(userid,choice))
	elif choice == 'online':
		playSound(userid,1)
		popupCreate(userid,2)
	elif choice == 'offline':
		if len(playerList) == 0:
			playSound(userid,0)
			whisper(userid,'Error: #greenOffline Playerlist is empty!')
			popupCreate(userid,1)
		else:
			playSound(userid,1)
			popupCreate(userid,3)
	elif choice == 'about':
		temp = popuplib.create('pod_profile_finder_about')
		temp.addline('Name: PoD-Profile-Finder')
		temp.addline('Version: %s' % es.ServerVar('pod_profile_finder_version'))
		temp.addline('Written by: TheSpeedFreak')
		temp.addline('Website: www.NextGenerationGaming.de')
		temp.addline(' ')
		temp.addline('Description:')
		temp.addline('Converts Steam IDs to Community IDs.')
		temp.send(userid)
		temp.delete()
	elif choice == 'help':
		temp = popuplib.create('pod_profile_finder_about')
		temp.addline('You can either pick a Player from a Playerlist')
		temp.addline('or type the Userid/Name/SteamID of the target')
		temp.addline('behind the command.')
		temp.addline(' ')
		temp.addline('Syntax:')
		if len(cmdList) > 0: temp.addline(cmdList[0]+' (<Target>)')
		temp.addline(' ')
		temp.addline('Valid Targets:')
		temp.addline('- Userid [Target must be on the Server]')
		temp.addline('- (Part of) Name [Target must be on the Server]')
		temp.addline('- STEAMID')
		temp.addline(' ')
		temp.addline('For example:')
		temp.addline('User Alfred with Userid 4 and STEAM_0:0:1')
		if len(cmdList) > 0: temp.addline(cmdList[0]+' 4')
		if len(cmdList) > 0: temp.addline(cmdList[0]+' Alf')
		if len(cmdList) > 0: temp.addline(cmdList[0]+' STEAM_0:0:1')
		temp.send(userid)
		temp.delete()

def whisper(userid,msg):
	es.tell(userid,'#multi','\x07000000[\x0720B2AAPoD-Profile-Finder\x07000000] \x0720B2AA%s' % str(msg))

def getSteamid(userid,steamid):
	if len(steamid) > 10 and steamid[7] == ':' and steamid[9] == ':':
		if steamid[6].isdigit() and steamid[8].isdigit() and steamid[10:len(steamid)].isdigit():
			i = int(steamid[8])
			accountNumber = int(steamid[10:len(steamid)])
			profileID = accountNumber*2+i+76561197960265728
			return profileID
	whisper(userid,'Error: #greenInvalid SteamID!')
	playSound(userid,0)
	return None

def openProfile(userid,communityID):
	if communityID != None:
		usermsg.motd(userid,0,'http://steamcommunity.com/profiles/%s' % communityID,'Loading Profile: http://steamcommunity.com/profiles/%s\nPlease wait...' % communityID)
		gamethread.delayed(1.0,usermsg.motd,(userid,2,'http://steamcommunity.com/profiles/%s' % communityID,'http://steamcommunity.com/profiles/%s' % communityID))

def playSound(userid,number):
	#0 = Denied
	#1 = Access
	if number == 0: es.playsound(userid,'buttons/button11.wav',1.0)
	if number == 1: es.playsound(userid,'UI/buttonclick.wav',1.0)